/* This file was generated by SableCC (http://www.sablecc.org/). */

package de.prob.unicode.lexer;

import java.io.*;
import java.util.*;
import de.prob.unicode.node.*;
import de.hhu.stups.sablecc.patch.*;
import java.util.concurrent.LinkedBlockingQueue;

@SuppressWarnings({"unused"}) 
public class Lexer implements ITokenListContainer
{
    protected Token token;
    protected State state = State.INITIAL;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();
    
	private List<IToken> tokenList;
    private final Queue<IToken> nextList = new LinkedBlockingQueue<IToken>();

	private IToken tok;

    public Queue<IToken> getNextList() {
        return nextList;
    }

	public List<IToken> getTokenList() {
		return tokenList;
	}
	
	private void setToken(Token t) {
	  tok = t;
   	  token = t;	
	}
	
	
	public void setTokenList(final List<IToken> list) {
		tokenList = list;
	}

     
    protected void filter() throws LexerException, IOException
    {
        // Do nothing
    }

    protected void filterWrap() throws LexerException, IOException
    {
       filter();
       if (token != null) {
	          getTokenList().add(token); 
              nextList.add(token);
	   }
    }


    public Lexer(  PushbackReader in)
    {
        this.in = in;
    	setTokenList(new ArrayList<IToken>());
    }
    
    public Token peek() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.setToken(getToken());
            filterWrap();
        }

        return (Token) nextList.peek();
    }

    public Token next() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.setToken(getToken());
            filterWrap();
        }

        Token result = (Token) nextList.poll();
        this.setToken(null);
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = this.pos;
        int start_line = this.line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

          int[][][] gotoTable = Lexer.gotoTable[this.state.id()];
          int[] accept = Lexer.accept[this.state.id()];
        this.text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(this.cr)
                    {
                        this.cr = false;
                    }
                    else
                    {
                        this.line++;
                        this.pos = 0;
                    }
                    break;
                case 13:
                    this.line++;
                    this.pos = 0;
                    this.cr = true;
                    break;
                default:
                    this.pos++;
                    this.cr = false;
                    break;
                }

                this.text.append((char) c);

                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = this.text.length();
                    accept_pos = this.pos;
                    accept_line = this.line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                              Token token = new0(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 1:
                        {
                              Token token = new1(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 2:
                        {
                              Token token = new2(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 3:
                        {
                              Token token = new3(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 4:
                        {
                              Token token = new4(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 5:
                        {
                              Token token = new5(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 6:
                        {
                              Token token = new6(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 7:
                        {
                              Token token = new7(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 8:
                        {
                              Token token = new8(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 9:
                        {
                              Token token = new9(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 10:
                        {
                              Token token = new10(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 11:
                        {
                              Token token = new11(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 12:
                        {
                              Token token = new12(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 13:
                        {
                              Token token = new13(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 14:
                        {
                              Token token = new14(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 15:
                        {
                              Token token = new15(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 16:
                        {
                              Token token = new16(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 17:
                        {
                              Token token = new17(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 18:
                        {
                              Token token = new18(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 19:
                        {
                              Token token = new19(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 20:
                        {
                              Token token = new20(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 21:
                        {
                              Token token = new21(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 22:
                        {
                              Token token = new22(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 23:
                        {
                              Token token = new23(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 24:
                        {
                              Token token = new24(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 25:
                        {
                              Token token = new25(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 26:
                        {
                              Token token = new26(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 27:
                        {
                              Token token = new27(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 28:
                        {
                              Token token = new28(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 29:
                        {
                              Token token = new29(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 30:
                        {
                              Token token = new30(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 31:
                        {
                              Token token = new31(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 32:
                        {
                              Token token = new32(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 33:
                        {
                              Token token = new33(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 34:
                        {
                              Token token = new34(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 35:
                        {
                              Token token = new35(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 36:
                        {
                              Token token = new36(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 37:
                        {
                              Token token = new37(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 38:
                        {
                              Token token = new38(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 39:
                        {
                              Token token = new39(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 40:
                        {
                              Token token = new40(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 41:
                        {
                              Token token = new41(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 42:
                        {
                              Token token = new42(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 43:
                        {
                              Token token = new43(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 44:
                        {
                              Token token = new44(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 45:
                        {
                              Token token = new45(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 46:
                        {
                              Token token = new46(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 47:
                        {
                              Token token = new47(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 48:
                        {
                              Token token = new48(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 49:
                        {
                              Token token = new49(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 50:
                        {
                              Token token = new50(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 51:
                        {
                              Token token = new51(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 52:
                        {
                              Token token = new52(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 53:
                        {
                              Token token = new53(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 54:
                        {
                              Token token = new54(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 55:
                        {
                              Token token = new55(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 56:
                        {
                              Token token = new56(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 57:
                        {
                              Token token = new57(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 58:
                        {
                              Token token = new58(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 59:
                        {
                              Token token = new59(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 60:
                        {
                              Token token = new60(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 61:
                        {
                              Token token = new61(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 62:
                        {
                              Token token = new62(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 63:
                        {
                              Token token = new63(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 64:
                        {
                              Token token = new64(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 65:
                        {
                              Token token = new65(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 66:
                        {
                              Token token = new66(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 67:
                        {
                              Token token = new67(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 68:
                        {
                              Token token = new68(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 69:
                        {
                              Token token = new69(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 70:
                        {
                              Token token = new70(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 71:
                        {
                              Token token = new71(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 72:
                        {
                              Token token = new72(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 73:
                        {
                              Token token = new73(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 74:
                        {
                              Token token = new74(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 75:
                        {
                              Token token = new75(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 76:
                        {
                              Token token = new76(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    }
                }
                else
                {
                    if(this.text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + this.text);
                    }

                      EOF token = new EOF(
                        start_line + 1,
                        start_pos + 1);
                    return token;
                }
            }
        }
    }

    Token new0(  String text,   int line,   int pos) { return new TString(text, line, pos); }
    Token new1(  int line,   int pos) { return new TTypeofOpen(line, pos); }
    Token new2(  int line,   int pos) { return new TTypeofClose(line, pos); }
    Token new3(  String text,   int line,   int pos) { return new TTruncatedSetSize(text, line, pos); }
    Token new4(  String text,   int line,   int pos) { return new TIn(text, line, pos); }
    Token new5(  String text,   int line,   int pos) { return new TNotsubseteq(text, line, pos); }
    Token new6(  String text,   int line,   int pos) { return new TNotsubset(text, line, pos); }
    Token new7(  String text,   int line,   int pos) { return new TSubseteq(text, line, pos); }
    Token new8(  String text,   int line,   int pos) { return new TSetminus(text, line, pos); }
    Token new9(  String text,   int line,   int pos) { return new TDotdot(text, line, pos); }
    Token new10(  String text,   int line,   int pos) { return new TDotdotdot(text, line, pos); }
    Token new11(  String text,   int line,   int pos) { return new TNat1(text, line, pos); }
    Token new12(  String text,   int line,   int pos) { return new TNat(text, line, pos); }
    Token new13(  String text,   int line,   int pos) { return new TEmptyset(text, line, pos); }
    Token new14(  String text,   int line,   int pos) { return new TBcmsuch(text, line, pos); }
    Token new15(  String text,   int line,   int pos) { return new TBfalse(text, line, pos); }
    Token new16(  String text,   int line,   int pos) { return new TForall(text, line, pos); }
    Token new17(  String text,   int line,   int pos) { return new TExists(text, line, pos); }
    Token new18(  String text,   int line,   int pos) { return new TMapsto(text, line, pos); }
    Token new19(  String text,   int line,   int pos) { return new TBtrue(text, line, pos); }
    Token new20(  String text,   int line,   int pos) { return new TSubset(text, line, pos); }
    Token new21(  String text,   int line,   int pos) { return new TBunion(text, line, pos); }
    Token new22(  String text,   int line,   int pos) { return new TBinter(text, line, pos); }
    Token new23(  String text,   int line,   int pos) { return new TDomres(text, line, pos); }
    Token new24(  String text,   int line,   int pos) { return new TRanres(text, line, pos); }
    Token new25(  String text,   int line,   int pos) { return new TDomsub(text, line, pos); }
    Token new26(  String text,   int line,   int pos) { return new TRansub(text, line, pos); }
    Token new27(  String text,   int line,   int pos) { return new TLambda(text, line, pos); }
    Token new28(  String text,   int line,   int pos) { return new TOftype(text, line, pos); }
    Token new29(  String text,   int line,   int pos) { return new TNotin(text, line, pos); }
    Token new30(  String text,   int line,   int pos) { return new TCprod(text, line, pos); }
    Token new31(  String text,   int line,   int pos) { return new TUnion(text, line, pos); }
    Token new32(  String text,   int line,   int pos) { return new TInter(text, line, pos); }
    Token new33(  String text,   int line,   int pos) { return new TFcomp(text, line, pos); }
    Token new34(  String text,   int line,   int pos) { return new TBcomp(text, line, pos); }
    Token new35(  String text,   int line,   int pos) { return new TStrel(text, line, pos); }
    Token new36(  String text,   int line,   int pos) { return new TDprod(text, line, pos); }
    Token new37(  String text,   int line,   int pos) { return new TPprod(text, line, pos); }
    Token new38(  String text,   int line,   int pos) { return new TBcmeq(text, line, pos); }
    Token new39(  String text,   int line,   int pos) { return new TBcmin(text, line, pos); }
    Token new40(  String text,   int line,   int pos) { return new TIntg(text, line, pos); }
    Token new41(  String text,   int line,   int pos) { return new TLand(text, line, pos); }
    Token new42(  String text,   int line,   int pos) { return new TLimp(text, line, pos); }
    Token new43(  String text,   int line,   int pos) { return new TLeqv(text, line, pos); }
    Token new44(  String text,   int line,   int pos) { return new TLnot(text, line, pos); }
    Token new45(  String text,   int line,   int pos) { return new TQdot(text, line, pos); }
    Token new46(  String text,   int line,   int pos) { return new TConv(text, line, pos); }
    Token new47(  String text,   int line,   int pos) { return new TTrel(text, line, pos); }
    Token new48(  String text,   int line,   int pos) { return new TSrel(text, line, pos); }
    Token new49(  String text,   int line,   int pos) { return new TPfun(text, line, pos); }
    Token new50(  String text,   int line,   int pos) { return new TTfun(text, line, pos); }
    Token new51(  String text,   int line,   int pos) { return new TPinj(text, line, pos); }
    Token new52(  String text,   int line,   int pos) { return new TTinj(text, line, pos); }
    Token new53(  String text,   int line,   int pos) { return new TPsur(text, line, pos); }
    Token new54(  String text,   int line,   int pos) { return new TTsur(text, line, pos); }
    Token new55(  String text,   int line,   int pos) { return new TTbij(text, line, pos); }
    Token new56(  String text,   int line,   int pos) { return new TExpn(text, line, pos); }
    Token new57(  String text,   int line,   int pos) { return new TLor(text, line, pos); }
    Token new58(  String text,   int line,   int pos) { return new TPow1(text, line, pos); }
    Token new59(  String text,   int line,   int pos) { return new TPow(text, line, pos); }
    Token new60(  String text,   int line,   int pos) { return new TMid(text, line, pos); }
    Token new61(  String text,   int line,   int pos) { return new TNeq(text, line, pos); }
    Token new62(  String text,   int line,   int pos) { return new TRel(text, line, pos); }
    Token new63(  String text,   int line,   int pos) { return new TOvl(text, line, pos); }
    Token new64(  String text,   int line,   int pos) { return new TLeq(text, line, pos); }
    Token new65(  String text,   int line,   int pos) { return new TGeq(text, line, pos); }
    Token new66(  String text,   int line,   int pos) { return new TDiv(text, line, pos); }
    Token new67(  String text,   int line,   int pos) { return new TMult(text, line, pos); }
    Token new68(  String text,   int line,   int pos) { return new TMinus(text, line, pos); }
    Token new69(  String text,   int line,   int pos) { return new TLbrace(text, line, pos); }
    Token new70(  String text,   int line,   int pos) { return new TRbrace(text, line, pos); }
    Token new71(  int line,   int pos) { return new TTake(line, pos); }
    Token new72(  int line,   int pos) { return new TDrop(line, pos); }
    Token new73(  String text,   int line,   int pos) { return new TIdentifierLiteral(text, line, pos); }
    Token new74(  String text,   int line,   int pos) { return new TAnyChar(text, line, pos); }
    Token new75(  String text,   int line,   int pos) { return new TWhitespace(text, line, pos); }
    Token new76(  String text,   int line,   int pos) { return new TSeparator(text, line, pos); }

    private int getChar() throws IOException
    {
        if(this.eof)
        {
            return -1;
        }

        int result = this.in.read();

        if(result == -1)
        {
            this.eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = this.text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            this.eof = false;

            this.in.unread(this.text.charAt(i));
        }
    }

    protected void unread(  Token token) throws IOException
    {
          String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            this.eof = false;

            this.in.unread(text.charAt(i));
        }

        this.pos = token.getPos() - 1;
        this.line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(this.text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable;
/*  {
        { // INITIAL
            {{0, 8, 1}, {9, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 31, 1}, {32, 32, 2}, {33, 33, 3}, {34, 34, 4}, {35, 35, 5}, {36, 36, 1}, {37, 37, 6}, {38, 38, 7}, {39, 39, 1}, {40, 41, 8}, {42, 42, 9}, {43, 43, 10}, {44, 44, 8}, {45, 45, 11}, {46, 46, 12}, {47, 47, 13}, {48, 57, 1}, {58, 58, 14}, {59, 59, 15}, {60, 60, 16}, {61, 61, 17}, {62, 62, 18}, {63, 64, 1}, {65, 72, 19}, {73, 73, 20}, {74, 77, 19}, {78, 78, 21}, {79, 79, 19}, {80, 80, 22}, {81, 84, 19}, {85, 85, 23}, {86, 90, 19}, {91, 91, 1}, {92, 92, 24}, {93, 93, 1}, {94, 94, 25}, {95, 96, 1}, {97, 98, 19}, {99, 99, 26}, {100, 101, 19}, {102, 102, 27}, {103, 109, 19}, {110, 110, 28}, {111, 111, 29}, {112, 115, 19}, {116, 116, 30}, {117, 122, 19}, {123, 123, 31}, {124, 124, 32}, {125, 125, 33}, {126, 126, 34}, {127, 171, 1}, {172, 172, 35}, {173, 182, 1}, {183, 183, 36}, {184, 214, 1}, {215, 215, 37}, {216, 246, 1}, {247, 247, 38}, {248, 954, 1}, {955, 955, 39}, {956, 8228, 1}, {8229, 8229, 40}, {8230, 8230, 41}, {8231, 8468, 1}, {8469, 8469, 42}, {8470, 8472, 1}, {8473, 8473, 43}, {8474, 8483, 1}, {8484, 8484, 44}, {8485, 8593, 1}, {8594, 8594, 45}, {8595, 8595, 1}, {8596, 8596, 46}, {8597, 8607, 1}, {8608, 8608, 47}, {8609, 8610, 1}, {8611, 8611, 48}, {8612, 8613, 1}, {8614, 8614, 49}, {8615, 8657, 1}, {8658, 8658, 50}, {8659, 8659, 1}, {8660, 8660, 51}, {8661, 8695, 1}, {8696, 8696, 52}, {8697, 8703, 1}, {8704, 8704, 53}, {8705, 8706, 1}, {8707, 8707, 54}, {8708, 8708, 1}, {8709, 8709, 55}, {8710, 8711, 1}, {8712, 8712, 56}, {8713, 8713, 57}, {8714, 8721, 1}, {8722, 8722, 58}, {8723, 8725, 1}, {8726, 8726, 59}, {8727, 8727, 60}, {8728, 8728, 61}, {8729, 8738, 1}, {8739, 8739, 62}, {8740, 8740, 1}, {8741, 8741, 63}, {8742, 8742, 1}, {8743, 8743, 64}, {8744, 8744, 65}, {8745, 8745, 66}, {8746, 8746, 67}, {8747, 8763, 1}, {8764, 8764, 68}, {8765, 8787, 1}, {8788, 8788, 69}, {8789, 8799, 1}, {8800, 8800, 70}, {8801, 8803, 1}, {8804, 8804, 71}, {8805, 8805, 72}, {8806, 8833, 1}, {8834, 8834, 73}, {8835, 8835, 1}, {8836, 8836, 74}, {8837, 8837, 1}, {8838, 8838, 75}, {8839, 8839, 1}, {8840, 8840, 76}, {8841, 8854, 1}, {8855, 8855, 77}, {8856, 8867, 1}, {8868, 8868, 78}, {8869, 8869, 79}, {8870, 8897, 1}, {8898, 8898, 80}, {8899, 8899, 81}, {8900, 9654, 1}, {9655, 9655, 82}, {9656, 9664, 1}, {9665, 9665, 83}, {9666, 10495, 1}, {10496, 10496, 84}, {10497, 10515, 1}, {10516, 10516, 85}, {10517, 10517, 1}, {10518, 10518, 86}, {10519, 10625, 1}, {10626, 10626, 87}, {10627, 10851, 1}, {10852, 10852, 88}, {10853, 10853, 89}, {10854, 57599, 1}, {57600, 57600, 90}, {57601, 57601, 91}, {57602, 57602, 92}, {57603, 57603, 93}, {57604, 65535, 1}, },
            {{0, 8, 1}, {11, 12, 1}, {14, 31, 1}, {36, 36, 1}, {39, 39, 1}, {48, 57, 1}, {63, 91, 1}, {93, 93, 1}, {95, 122, 1}, {127, 171, 1}, {173, 182, 1}, {184, 214, 1}, {216, 246, 1}, {248, 954, 1}, {956, 8228, 1}, {8230, 8468, 1}, {8470, 8472, 1}, {8474, 8483, 1}, {8485, 8593, 1}, {8595, 8595, 1}, {8597, 8607, 1}, {8609, 8610, 1}, {8612, 8613, 1}, {8615, 8657, 1}, {8659, 8659, 1}, {8661, 8695, 1}, {8697, 8703, 1}, {8705, 8706, 1}, {8708, 8708, 1}, {8710, 8711, 1}, {8714, 8721, 1}, {8723, 8725, 1}, {8729, 8738, 1}, {8740, 8740, 1}, {8742, 8742, 1}, {8747, 8763, 1}, {8765, 8787, 1}, {8789, 8799, 1}, {8801, 8803, 1}, {8806, 8833, 1}, {8835, 8835, 1}, {8837, 8837, 1}, {8839, 8839, 1}, {8841, 8854, 1}, {8856, 8867, 1}, {8870, 8897, 1}, {8900, 9654, 1}, {9656, 9664, 1}, {9666, 10495, 1}, {10497, 10515, 1}, {10517, 10517, 1}, {10519, 10625, 1}, {10627, 10851, 1}, {10854, 57599, 1}, {57604, 65535, 1}, },
            {{9, 10, 2}, {13, 13, 2}, {32, 32, 2}, },
            {},
            {{0, 33, 94}, {34, 34, 95}, {35, 91, 94}, {92, 92, 96}, {93, 65535, 94}, },
            {{48, 57, 97}, },
            {},
            {},
            {},
            {{42, 42, 98}, {47, 47, 99}, },
            {{45, 45, 100}, {62, 62, 101}, },
            {{45, 45, 102}, {62, 62, 103}, },
            {{46, 46, 104}, },
            {{42, 42, 105}, {58, 58, 106}, {60, 60, 107}, {61, 61, 108}, {92, 92, 109}, {124, 124, 110}, },
            {{58, 58, 111}, {61, 61, 112}, {124, 124, 113}, {8712, 8712, 114}, {8739, 8739, 115}, },
            {},
            {{43, 43, 116}, {45, 45, 117}, {58, 58, 118}, {60, 60, 119}, {61, 61, 120}, {124, 124, 121}, },
            {{62, 62, 122}, },
            {{43, 43, 123}, {45, 45, 124}, {60, 60, 125}, {61, 61, 126}, },
            {{0, 39, -3}, {48, 57, 127}, {63, 64, 1}, {65, 90, 128}, {91, 91, 1}, {93, 93, 1}, {95, 95, 129}, {96, 96, 1}, {97, 122, 128}, {127, 65535, -3}, },
            {{0, 64, -21}, {65, 77, 128}, {78, 78, 130}, {79, 90, 128}, {91, 65535, -21}, },
            {{0, 64, -21}, {65, 65, 131}, {66, 90, 128}, {91, 65535, -21}, },
            {{0, 64, -21}, {65, 78, 128}, {79, 79, 132}, {80, 90, 128}, {91, 65535, -21}, },
            {{0, 77, -22}, {78, 78, 133}, {79, 65535, -22}, },
            {{35, 35, 134}, {47, 47, 135}, {73, 73, 136}, {85, 85, 137}, {98, 98, 138}, {99, 99, 139}, {100, 100, 140}, {101, 101, 141}, {102, 102, 142}, {103, 103, 143}, {105, 105, 144}, {108, 108, 145}, {109, 109, 146}, {110, 110, 147}, {111, 111, 148}, {112, 112, 149}, {113, 113, 150}, {114, 114, 151}, {115, 115, 152}, {116, 116, 153}, {117, 117, 154}, {123, 123, 155}, {124, 124, 156}, {125, 125, 157}, },
            {},
            {{0, 96, -21}, {97, 104, 128}, {105, 105, 158}, {106, 122, 128}, {127, 65535, -3}, },
            {{0, 96, -21}, {97, 97, 159}, {98, 122, 128}, {127, 65535, -3}, },
            {{0, 96, -21}, {97, 110, 128}, {111, 111, 160}, {112, 122, 128}, {127, 65535, -3}, },
            {{0, 96, -21}, {97, 101, 128}, {102, 102, 161}, {103, 113, 128}, {114, 114, 162}, {115, 122, 128}, {127, 65535, -3}, },
            {{0, 96, -21}, {97, 113, 128}, {114, 114, 163}, {115, 65535, -31}, },
            {{125, 125, 164}, },
            {{45, 45, 165}, {62, 62, 166}, {124, 124, 167}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {{0, 65535, -3}, },
            {{49, 49, 168}, },
            {{49, 49, 169}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {{0, 65535, -6}, },
            {},
            {{0, 65535, 170}, },
            {{48, 57, 97}, },
            {},
            {},
            {{62, 62, 171}, },
            {{62, 62, 172}, },
            {{62, 62, 173}, },
            {{62, 62, 174}, },
            {{46, 46, 175}, },
            {},
            {},
            {{58, 58, 176}, {60, 60, 177}, },
            {},
            {},
            {{92, 92, 178}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {{62, 62, 179}, },
            {},
            {{45, 45, 180}, {58, 58, 181}, {124, 124, 182}, },
            {{62, 62, 183}, },
            {},
            {},
            {{62, 62, 184}, },
            {{62, 62, 185}, },
            {},
            {},
            {{0, 65535, -21}, },
            {{0, 65535, -21}, },
            {{0, 65535, -21}, },
            {{0, 64, -21}, {65, 83, 128}, {84, 84, 186}, {85, 90, 128}, {91, 65535, -21}, },
            {{0, 83, -132}, {84, 84, 187}, {85, 65535, -132}, },
            {{0, 64, -21}, {65, 86, 128}, {87, 87, 188}, {88, 90, 128}, {91, 65535, -21}, },
            {{0, 64, -21}, {65, 72, 128}, {73, 73, 189}, {74, 90, 128}, {91, 65535, -21}, },
            {{48, 57, 97}, },
            {},
            {{110, 110, 190}, },
            {{110, 110, 191}, },
            {{99, 99, 192}, {102, 102, 193}, {105, 105, 194}, {116, 116, 195}, {117, 117, 196}, },
            {{111, 111, 197}, {112, 112, 198}, },
            {{105, 105, 199}, {111, 111, 200}, {112, 112, 201}, },
            {{109, 109, 202}, {120, 120, 203}, },
            {{99, 99, 204}, {111, 111, 205}, },
            {{101, 101, 206}, },
            {{110, 110, 207}, },
            {{97, 97, 208}, {100, 100, 209}, {101, 101, 210}, {105, 105, 211}, {110, 110, 212}, {111, 111, 213}, },
            {{97, 97, 214}, {105, 105, 215}, },
            {{97, 97, 216}, {101, 101, 217}, {111, 111, 218}, },
            {{102, 102, 219}, {118, 118, 220}, },
            {{102, 102, 221}, {105, 105, 222}, {111, 111, 223}, {112, 112, 224}, {115, 115, 225}, },
            {{100, 100, 226}, },
            {{97, 97, 227}, {101, 101, 228}, },
            {{101, 101, 229}, {114, 114, 230}, {116, 116, 231}, {117, 117, 232}, },
            {{98, 98, 233}, {102, 102, 234}, {105, 105, 235}, {114, 114, 236}, {115, 115, 237}, },
            {{112, 112, 238}, },
            {},
            {{47, 47, 239}, },
            {},
            {{0, 113, -32}, {114, 114, 240}, {115, 65535, -31}, },
            {{0, 96, -21}, {97, 107, 128}, {108, 108, 241}, {109, 122, 128}, {127, 65535, -3}, },
            {{0, 96, -21}, {97, 115, 128}, {116, 116, 242}, {117, 122, 128}, {127, 65535, -3}, },
            {{0, 115, -162}, {116, 116, 243}, {117, 65535, -162}, },
            {{0, 65535, -21}, },
            {{0, 96, -21}, {97, 116, 128}, {117, 117, 244}, {118, 122, 128}, {127, 65535, -3}, },
            {},
            {{62, 62, 245}, },
            {{62, 62, 246}, },
            {},
            {},
            {},
            {{0, 65535, -6}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {{58, 58, 247}, },
            {},
            {{62, 62, 248}, },
            {{62, 62, 249}, },
            {},
            {},
            {},
            {},
            {{62, 62, 250}, },
            {{0, 64, -21}, {65, 68, 128}, {69, 69, 251}, {70, 90, 128}, {91, 65535, -21}, },
            {{0, 39, -3}, {48, 48, 127}, {49, 49, 252}, {50, 57, 127}, {63, 65535, -21}, },
            {{0, 48, -189}, {49, 49, 253}, {50, 65535, -189}, },
            {{0, 78, -24}, {79, 79, 254}, {80, 65535, -24}, },
            {{116, 116, 255}, },
            {{105, 105, 256}, },
            {{109, 109, 257}, {111, 111, 258}, },
            {{97, 97, 259}, },
            {{110, 110, 260}, },
            {{114, 114, 261}, },
            {{110, 110, 262}, },
            {{110, 110, 263}, },
            {{114, 114, 264}, },
            {{118, 118, 265}, },
            {{109, 109, 266}, },
            {{114, 114, 267}, },
            {{112, 112, 268}, },
            {{105, 105, 269}, {112, 112, 270}, },
            {{111, 111, 271}, },
            {{114, 114, 272}, },
            {{113, 113, 273}, },
            {{116, 116, 274}, },
            {{109, 109, 275}, {110, 110, 276}, },
            {{111, 111, 277}, },
            {{113, 113, 278}, },
            {{109, 109, 279}, },
            {{111, 111, 280}, },
            {{114, 114, 281}, },
            {{112, 112, 282}, },
            {{100, 100, 283}, },
            {{116, 116, 284}, },
            {{113, 113, 285}, },
            {{116, 116, 286}, },
            {{116, 116, 287}, },
            {{108, 108, 288}, },
            {{117, 117, 289}, },
            {{110, 110, 290}, },
            {{119, 119, 291}, },
            {{114, 114, 292}, },
            {{117, 117, 293}, },
            {{111, 111, 294}, },
            {{110, 110, 295}, },
            {{108, 108, 296}, },
            {{116, 116, 297}, },
            {{101, 101, 298}, },
            {{114, 114, 299}, },
            {{98, 98, 300}, },
            {{105, 105, 301}, },
            {{117, 117, 302}, },
            {{110, 110, 303}, },
            {{101, 101, 304}, },
            {{117, 117, 305}, },
            {{116, 116, 306}, },
            {},
            {{0, 96, -21}, {97, 98, 128}, {99, 99, 307}, {100, 122, 128}, {127, 65535, -3}, },
            {{0, 96, -21}, {97, 114, 128}, {115, 115, 308}, {116, 122, 128}, {127, 65535, -3}, },
            {{0, 65535, -21}, },
            {{0, 96, -21}, {97, 120, 128}, {121, 121, 309}, {122, 122, 128}, {127, 65535, -3}, },
            {{0, 96, -21}, {97, 100, 128}, {101, 101, 310}, {102, 122, 128}, {127, 65535, -3}, },
            {},
            {},
            {},
            {},
            {{62, 62, 311}, },
            {},
            {{0, 64, -21}, {65, 81, 128}, {82, 82, 312}, {83, 90, 128}, {91, 65535, -21}, },
            {{0, 65535, -21}, },
            {{0, 65535, -21}, },
            {{0, 77, -22}, {78, 78, 313}, {79, 65535, -22}, },
            {{101, 101, 314}, },
            {{111, 111, 315}, },
            {{101, 101, 316}, {105, 105, 317}, {115, 115, 318}, },
            {{109, 109, 319}, },
            {{108, 108, 320}, },
            {{116, 116, 321}, },
            {{117, 117, 322}, },
            {{105, 105, 323}, },
            {{118, 118, 324}, },
            {{111, 111, 325}, },
            {},
            {{114, 114, 326}, {115, 115, 327}, },
            {{111, 111, 328}, },
            {{116, 116, 329}, },
            {{115, 115, 330}, },
            {{110, 110, 331}, },
            {{109, 109, 332}, },
            {{97, 97, 333}, },
            {},
            {{103, 103, 334}, },
            {{98, 98, 335}, },
            {{100, 100, 336}, },
            {{116, 116, 337}, },
            {{118, 118, 338}, },
            {{112, 112, 339}, },
            {{116, 116, 340}, },
            {},
            {{115, 115, 341}, },
            {},
            {{49, 49, 342}, },
            {},
            {{105, 105, 343}, {115, 115, 344}, },
            {{121, 121, 345}, },
            {},
            {{110, 110, 346}, },
            {{106, 106, 347}, },
            {{49, 49, 348}, },
            {{111, 111, 349}, },
            {{114, 114, 350}, },
            {{116, 116, 351}, },
            {{114, 114, 352}, {115, 115, 353}, },
            {},
            {{109, 109, 354}, },
            {{108, 108, 355}, },
            {{101, 101, 356}, },
            {{115, 115, 357}, },
            {{106, 106, 358}, },
            {{110, 110, 359}, },
            {{106, 106, 360}, },
            {{108, 108, 361}, },
            {{114, 114, 362}, },
            {{111, 111, 363}, },
            {{0, 65535, -21}, },
            {{0, 100, -246}, {101, 101, 364}, {102, 65535, -246}, },
            {{0, 96, -21}, {97, 111, 128}, {112, 112, 365}, {113, 122, 128}, {127, 65535, -3}, },
            {{0, 65535, -21}, },
            {},
            {{0, 65535, -21}, },
            {{0, 65535, -21}, },
            {{114, 114, 366}, },
            {{110, 110, 367}, },
            {{113, 113, 368}, },
            {{110, 110, 369}, },
            {{117, 117, 370}, },
            {{112, 112, 371}, },
            {{115, 115, 372}, },
            {{101, 101, 373}, },
            {{101, 101, 374}, },
            {{111, 111, 375}, },
            {},
            {{100, 100, 376}, },
            {{101, 101, 377}, },
            {{117, 117, 378}, },
            {{100, 100, 379}, },
            {{121, 121, 380}, },
            {{116, 116, 381}, },
            {},
            {{112, 112, 382}, },
            {{108, 108, 383}, },
            {},
            {{100, 100, 384}, },
            {},
            {{115, 115, 385}, },
            {},
            {},
            {},
            {{116, 116, 386}, },
            {},
            {{110, 110, 387}, },
            {{117, 117, 388}, },
            {{112, 112, 389}, },
            {},
            {},
            {},
            {{100, 100, 390}, },
            {},
            {},
            {{101, 101, 391}, },
            {{117, 117, 392}, },
            {{105, 105, 393}, },
            {},
            {{108, 108, 394}, },
            {{101, 101, 395}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {{0, 65535, -21}, },
            {{0, 100, -246}, {101, 101, 396}, {102, 65535, -246}, },
            {},
            {},
            {},
            {},
            {{99, 99, 397}, },
            {},
            {{101, 101, 398}, },
            {{114, 114, 399}, },
            {},
            {{110, 110, 400}, },
            {},
            {{115, 115, 401}, },
            {{98, 98, 402}, },
            {},
            {{115, 115, 403}, },
            {{115, 115, 404}, },
            {},
            {{108, 108, 405}, },
            {{97, 97, 406}, },
            {},
            {{111, 111, 407}, },
            {},
            {{98, 98, 408}, },
            {{101, 101, 409}, },
            {},
            {{115, 115, 410}, },
            {{98, 98, 411}, },
            {{110, 110, 412}, },
            {},
            {{116, 116, 413}, },
            {{0, 65535, -21}, },
            {{104, 104, 414}, },
            {},
            {},
            {},
            {},
            {},
            {{101, 101, 415}, },
            {},
            {},
            {},
            {},
            {{115, 115, 416}, },
            {},
            {},
            {},
            {{117, 117, 417}, },
            {{101, 101, 418}, },
            {},
            {{116, 116, 419}, },
            {{101, 101, 420}, },
            {{115, 115, 421}, },
            {{113, 113, 422}, },
            {},
            {{116, 116, 423}, },
            {},
            {},
            {{101, 101, 424}, },
            {{113, 113, 425}, },
            {},
        }
    };*/

    private static int[][] accept;
/*  {
        // INITIAL
        {74, 74, 75, 16, -1, 17, 27, 41, 76, 67, 76, 68, 45, 66, 4, 33, 76, 76, 76, 73, 73, 73, 73, 73, 8, 56, 73, 73, 73, 73, 73, 69, 60, 70, 46, 44, 45, 30, 66, 27, 9, 10, 12, 59, 40, 50, 62, 54, 52, 18, 42, 43, 49, 16, 17, 13, 4, 29, 68, 8, 67, 34, 60, 37, 41, 57, 22, 21, 46, 38, 61, 64, 65, 20, 6, 7, 5, 36, 19, 15, 32, 31, 24, 23, 53, 51, 55, 28, 25, 26, 47, 48, 35, 63, -1, 0, -1, 3, 30, 2, -1, -1, -1, -1, 9, 1, 29, -1, 61, 22, -1, 39, 38, 14, 39, 14, 63, -1, 7, -1, 64, 23, 42, -1, -1, 36, 65, 73, 73, 73, 73, 73, 73, 73, -1, 21, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 69, -1, 70, 73, 73, 73, 73, 57, 73, 13, -1, 24, 37, 11, 58, -1, 49, 53, 50, 54, 10, 5, -1, 71, 62, -1, 20, 25, 43, 51, 52, 40, 12, 59, 73, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 4, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 72, 73, 73, 44, 73, 73, 18, 26, 6, 48, 47, 55, 73, 11, 58, 73, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 66, -1, -1, -1, -1, -1, -1, -1, 65, -1, -1, -1, -1, 64, -1, -1, 57, -1, 60, 12, 61, -1, -1, 63, -1, -1, 59, -1, -1, -1, -1, 62, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 34, 73, 73, 19, 35, 32, 31, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 46, -1, -1, -1, -1, -1, -1, 56, -1, -1, 40, -1, 41, -1, 43, 42, 44, -1, 11, -1, -1, -1, 49, 51, 58, -1, 53, 45, -1, -1, -1, 48, -1, -1, 55, 50, 52, 47, 54, 9, 15, 73, 32, 31, 38, 39, -1, 34, -1, -1, 19, -1, 30, -1, -1, 36, -1, -1, 33, -1, -1, 10, -1, 29, -1, -1, 37, -1, -1, -1, 35, -1, 28, -1, 15, 22, 21, 23, 25, -1, 17, 16, 27, 18, -1, 28, 24, 26, -1, 20, 14, -1, -1, -1, -1, 13, -1, 8, 7, 6, -1, 5, },

    };*/

    public static class State
    {
        public final static State INITIAL = new State(0);

        private int id;

        private State(  int id)
        {
            this.id = id;
        }

        public int id()
        {
            return this.id;
        }
    }

    static 
    {
        try
        {
            DataInputStream s = new DataInputStream(
                new BufferedInputStream(
                Lexer.class.getResourceAsStream("lexer.dat")));

            // read gotoTable
            int length = s.readInt();
            gotoTable = new int[length][][][];
            for(int i = 0; i < gotoTable.length; i++)
            {
                length = s.readInt();
                gotoTable[i] = new int[length][][];
                for(int j = 0; j < gotoTable[i].length; j++)
                {
                    length = s.readInt();
                    gotoTable[i][j] = new int[length][3];
                    for(int k = 0; k < gotoTable[i][j].length; k++)
                    {
                        for(int l = 0; l < 3; l++)
                        {
                            gotoTable[i][j][k][l] = s.readInt();
                        }
                    }
                }
            }

            // read accept
            length = s.readInt();
            accept = new int[length][];
            for(int i = 0; i < accept.length; i++)
            {
                length = s.readInt();
                accept[i] = new int[length];
                for(int j = 0; j < accept[i].length; j++)
                {
                    accept[i][j] = s.readInt();
                }
            }

            s.close();
        }
        catch(Exception e)
        {
            throw new RuntimeException("The file \"lexer.dat\" is either missing or corrupted.");
        }
    }
}
